var BSON = require('bson').BSONPure.BSON
  , Processor = require('buffer-to-messages');

module.exports = function (inStream, outStream) {

    if (!outStream)
      outStream = inStream;

    inStream._parseMessage = function(msg) {
      this.emit('message', msg);
    };

    inStream._p = new Processor(4, function(message) {
      try {
        var data = BSON.deserialize(message);
        inStream._parseMessage(data);
      } catch (e) {
        e.buffer = message;
        inStream.emit('error', e);
      }
    });

    inStream.on('data', function(d) {
      this._p.process(d);
    });

    outStream.send = outStream._send = function(json) {
      var msg = BSON.serialize(json);
      this.write(inStream._p.createPrefix(msg));
      this.write(msg);
    };

};
